#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <cassert>
using namespace std;
#define TASK "occupation"
const int N = 1e5 + 10;
const int LOGN = 17;

vector<int> g[N];

int pos[N];
bool compareByTin(int x, int y) {
    return pos[x] < pos[y];
}

set<int, bool (*)(int, int)> occupated(compareByTin);

void enumerate(int v, int p) {

}

int main() {
    freopen(TASK".in", "r", stdin);
    freopen(TASK".out", "w", stdout);

    int n, m;
    cin >> n;
    int x, y;
    for (int i = 0; i < n - 1; ++i) {
        scanf("%d%d", &x, &y);
        --x;
        --y;
        g[x].push_back(y);
        g[y].push_back(x);
    }

    int leaf = 0, p = 0, pleaf;
    while (g[leaf].size() > 1) {
        pleaf = leaf;
        if (p == g[leaf][0]) leaf = g[leaf][1];
        else leaf = g[leaf][0];
        p = pleaf;
    }

    if (n > 1) {
        p = leaf;
        leaf = g[leaf][0];
        int nxt;
        while (g[leaf].size() > 1) {
            pos[leaf] = pos[p] + 1;

            if (g[leaf][0] != p) nxt = g[leaf][0];
            else nxt = g[leaf][1];

            p = leaf;
            leaf = nxt;
        }
        assert(pos[p] == n - 2);
        pos[leaf] = n - 1;
    }

    cin >> m;
    int lb, rb;
    for (int i = 0; i < m; ++i) {
        int t, x, y;
        scanf("%d", &t);
        if (t == 1) {
            scanf("%d", &x);
            --x;
            if (occupated.find(x) != occupated.end()) {
                occupated.erase(x);
                if (occupated.size() == 0) lb = rb = -1;
                else {
                    lb = pos[*occupated.begin()];
                    rb = pos[*occupated.rbegin()];
                }
            } else {
                occupated.insert(x);
                lb = pos[*occupated.begin()];
                rb = pos[*occupated.rbegin()];
            }
        } else if (t == 2) {
            scanf("%d%d", &x, &y);
            --x;
            --y;
            int lq = min(pos[x], pos[y]);
            int rq = max(pos[x], pos[y]);
            printf("%d\n", max(0, min(rq, rb) - max(lq, lb) + 1));
        }
    }
    return 0;
}
